package com.loafle.crawler.snmp;

import java.util.Map;

/**
 * Created by insanity on 17. 4. 10.
 */
public class Crawler {

    //v2c
    private static String addr = "192.168.1.215";
    private static String port = "161";
    private static String community = "public";

    /**
     * v3
     * loafle MD5 "qwer5795" DES "qweqwe123" : AUTHPRIV
     * loafle2 SHA "qwer5795" AES "qweqwe123" : AUTHPRIV
     * loafle3 MD5 "qwer5795" : AUTHNOPRIV
     * loafle4 :NOAUTHNOPRIV
     */
    private static String user = "loafle3";
    private static int authType = 1;
    private static String authPass = "qwer5795";
    private static int privType = 0;
    private static String privPass = "qweqwe123";

    public static void main(String[] args) {
        useV2c();
        useV3();
    }

    private static void useV2c() {
        try {
            SNMPv2c snmp = new SNMPv2c();

            Map walkResult = snmp.walk(addr, port, community, "1.3.6.1.2.1.25.2.3.1.3");
            printResult(walkResult);
            Map getResult = snmp.get(addr, port, community, new String[]{"1.3.6.1.2.1.1.5.0", "1.3.6.1.2.1.2.2.1.6.2"});
            printResult(getResult);

        } catch (Exception e) {
            System.err.println("An Exception happend as follows.");
            System.err.println(e.getMessage());
            e.printStackTrace();
        }
    }

    private static void useV3() {
        try {
            SNMPv3 snmp = new SNMPv3();

            Map walkResult = snmp.walk(addr, port, user, authType, authPass, privType, privPass, "1.3.6.1.2.1.25.2.3.1.3");
            printResult(walkResult);
            Map getResult = snmp.get(addr, port, user, authType, authPass, privType, privPass, new String[]{"1.3.6.1.2.1.1.5.0", "1.3.6.1.2.1.2.2.1.6.2"});
            printResult(getResult);
        } catch (Exception e) {
            System.err.println("An Exception happend as follows.");
            System.err.println(e.getMessage());
            e.printStackTrace();
        }
    }

    private static void printResult(Map<String, String> result) {

        for (Map.Entry<String, String> entry : result.entrySet()) {
            System.out.printf("key: %s - value: %s\n", entry.getKey(), entry.getValue());
        }

    }
}